/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#define Nul_Hyp 0

/********  Variables for  Permutation  of affectation status *************/
int   trt_data_Tag = 0;
int  *tot_affected = NULL;
int  *tot_unaffected = NULL;
int  *Total_Size = NULL;
int  *trt_data = NULL;
int  *trt_obs = NULL;
double *Param_Val_Array = NULL;
double **Val_Array = NULL;
double ***newstat = NULL;/*** S_{aff-Unaff} **/
double ***robdomstat = NULL;/*** S_{rob dom}  ***/
double ***spairs = NULL;/*** S_{pairs}  ****/
double ***newstat_Lambda = NULL;        /* IBD measure S_{lambda}$ */
double *paff = NULL;
/***********variables for test under normality *******************/
double ***Statistic = NULL;
double **Mean_Val = NULL;
double **Variance_Val = NULL;
double Weight = 0;
double *base = NULL;
int **exint = NULL;
int **exint1 = NULL;
/* Variables for likelihood-based test **********/
double *****likelihood_chi = NULL;
int  *n_founders = NULL;
double *minval_chi = NULL;
double *maxval_chi = NULL;
double *delta_Max_chi = NULL;
/**** Delta Method *******/
double value_S = 0;
double *nullmean = NULL;
double *nullvariance = NULL;
double *nullmeandelta_chi = NULL;
double *nullvariancedelta_chi = NULL;
double **Stat_chi = NULL;
double *likestat = NULL;
int  *store_index = NULL;
double **deltaStat = NULL;
double *delta_Val = NULL;
double null_delta_like = 0;
int **aff_array = NULL;
int **unaff_array = NULL;
int **trait_array = NULL;
double **Covariance = NULL;
double **Variance1 = NULL;
double **Variance2 = NULL;

/**
 * Function for initializing variables for lm_ibdtests
 */
void initialize_variables (int SEG_LAMBDA, int nloc)
{
   int   c, locus, i, tagval;

   if (Lambda_pOn || DeltaOn)
   {
      trt_data = (int *) calloc (pedsize, sizeof (int));
      alloc_chk (WHERE, trt_data);
      trt_obs = (int *) calloc (pedsize, sizeof (int));
      alloc_chk (WHERE, trt_obs);

      for (i = 0; i < pedsize; i++)
      {
         if (nghd[i].d_dat != NULL)
         {
            trt_obs[i] = nghd[i].d_dat[0];
         }
         else
            trt_obs[i] = 0;
      }
   }

   if (LambdaOn)
   {
      Param_Val_Array = (double *) calloc (SEG_LAMBDA + 1, sizeof (double));
      alloc_chk (WHERE, Param_Val_Array);
      paff = (double *) calloc (pedsize, sizeof (double));
      alloc_chk (WHERE, paff);
   }

   if (NormalEnable)
   {
      Statistic = (double ***) calloc (n_compnts, sizeof (double **));
      alloc_chk (WHERE, Statistic);
      for (c = 0; c < n_compnts; c++)
      {
         Statistic[c] = (double **) calloc (nloc + 1, sizeof (double *));
         alloc_chk (WHERE, Statistic[c]);
         for (locus = 0; locus <= nloc; locus++)
         {
            int   nNumOfStatInd = RobdomOn + SAffUnaffOn + LambdaOn + SpairsOn;
            Statistic[c][locus] =
               (double *) calloc (nNumOfStatInd, sizeof (double));
            alloc_chk (WHERE, Statistic[c][locus]);
         }
      }
   }

   if (PermutEnable)
   {
      tot_affected = (int *) calloc (n_compnts, sizeof (int));
      alloc_chk (WHERE, tot_affected);

      tot_unaffected = (int *) calloc (n_compnts, sizeof (int));
      alloc_chk (WHERE, tot_unaffected);

      Total_Size = (int *) calloc (n_compnts, sizeof (int));
      alloc_chk (WHERE, Total_Size);
      exint = (int **) calloc (n_compnts, sizeof (int *));
      alloc_chk (WHERE, exint);

      if (SAffUnaffOn)
      {
         exint1 = (int **) calloc (n_compnts, sizeof (int *));
         alloc_chk (WHERE, exint1);
      }

      for (c = 0; c < n_compnts; c++)
      {
         for (i = 0; i < Group[c]; i++)
         {
            tot_affected[c] = tot_affected[c] + size_aff[c][i];
            tot_unaffected[c] = tot_unaffected[c] + size_unaff[c][i];
            Total_Size[c] = Total_Size[c] + Size[c][i];
         }
      }

      for (c = 0; c < n_compnts; c++)
      {
         exint[c] = (int *) calloc ((Total_Size[c] + 2), sizeof (int));
         alloc_chk (WHERE, exint[c]);
         if (SAffUnaffOn)
         {
            exint1[c] =
               (int *) calloc ((2 * Group[c] + Total_Size[c] + 1),
                               sizeof (int));
            alloc_chk (WHERE, exint1[c]);
         }
      }
      if (SAffUnaffOn)
      {
         for (c = 0; c < n_compnts; c++)
         {
            exint1[c][0] = Group[c];
            for (i = 0; i < Group[c]; i++)
            {
               exint1[c][i + 1] = size_aff[c][i];
            }

            for (i = 0; i < Group[c]; i++)
            {
               exint1[c][Group[c] + i + 1] = size_unaff[c][i];
            }
         }
      }
   }
   if (RobdomOn)
   {
      robdomstat = alloc_3_dim_array (n_compnts, NPermutIt, nloc + 1);
      alloc_chk (WHERE, robdomstat);
      base = (double *) calloc (2, sizeof (double));
      alloc_chk (WHERE, base);
   }
   if (LambdaOn)
   {
      newstat_Lambda = alloc_3_dim_array (n_compnts, NPermutIt, nloc + 1);
      alloc_chk (WHERE, newstat_Lambda);
   }
   if (SAffUnaffOn)
   {
      newstat = alloc_3_dim_array (n_compnts, NPermutIt, nloc + 1);
      alloc_chk (WHERE, newstat);
   }
   if (SpairsOn)
   {
      spairs = alloc_3_dim_array (n_compnts, NPermutIt, nloc + 1);
      alloc_chk (WHERE, spairs);
   }

   if (NormalEnable)
   {
      tagval = SAffUnaffOn + SpairsOn + RobdomOn + LambdaOn;
      Mean_Val = (double **) calloc (n_compnts, sizeof (double *));
      alloc_chk (WHERE, Mean_Val);
      Variance_Val = (double **) calloc (n_compnts, sizeof (double *));
      alloc_chk (WHERE, Variance_Val);
      for (c = 0; c < n_compnts; c++)
      {
         Mean_Val[c] = (double *) calloc (tagval, sizeof (double));
         alloc_chk (WHERE, Mean_Val[c]);
         Variance_Val[c] = (double *) calloc (tagval, sizeof (double));
         alloc_chk (WHERE, Variance_Val[c]);
      }
   }
   if (LambdaOn)
   {
      Val_Array = (double **) calloc (n_compnts, sizeof (double *));
      alloc_chk (WHERE, Val_Array);
      for (c = 0; c < n_compnts; c++)
      {
         Val_Array[c] =
            (double *) calloc ((pedsize + SEG_LAMBDA + 2), sizeof (double));
         alloc_chk (WHERE, Val_Array);
      }
   }
   if (ChiSqEnable && Lambda_pOn)
   {
      likelihood_chi =
         alloc_5_dim_array (n_compnts, nloc + 1, NumOfSegL, NumOfSegL,
                            NumOfSegP);
      alloc_chk (WHERE, likelihood_chi);
      likestat = (double *) calloc (nloc + 1, sizeof (double));
      alloc_chk (WHERE, likestat);
      store_index = (int *) calloc (nloc + 1, sizeof (int));
      alloc_chk (WHERE, store_index);
      Covariance = (double **) calloc (nloc + 1, sizeof (double *));
      alloc_chk (WHERE, Covariance);
      Variance1 = (double **) calloc (nloc + 1, sizeof (double *));
      alloc_chk (WHERE, Variance1);
      Variance2 = (double **) calloc (nloc + 1, sizeof (double *));
      alloc_chk (WHERE, Variance2);
      for (locus = 0; locus <= nloc; locus++)
      {
         Covariance[locus] = (double *) calloc (NumOfSegP, sizeof (double));
         alloc_chk (WHERE, Covariance[locus]);
         Variance1[locus] = (double *) calloc (NumOfSegP, sizeof (double));
         alloc_chk (WHERE, Variance1[locus]);
         Variance2[locus] = (double *) calloc (NumOfSegP, sizeof (double));
         alloc_chk (WHERE, Variance2[locus]);
      }
      n_founders = (int *) calloc (n_compnts, sizeof (int));
      alloc_chk (WHERE, n_founders);

      for (c = 0; c < n_compnts; c++)
      {
         for (i = 0; i < pedsize; i++)
         {
            if (nghd[i].component == (c + 1))
            {
               /** Calculate number of founders per component **/
               if ((nghd[i].pa == &nullnode) && (nghd[i].ma == &nullnode))
                  n_founders[c] = n_founders[c] + 1;
            }
         }
      }
   }

   if (ChiSqEnable && DeltaOn)
   {
      nullmeandelta_chi = (double *) calloc (n_compnts, sizeof (double));
      alloc_chk (WHERE, nullmeandelta_chi);
      nullvariancedelta_chi = (double *) calloc (n_compnts, sizeof (double));
      alloc_chk (WHERE, nullvariancedelta_chi);
      minval_chi = (double *) calloc (n_compnts, sizeof (double));
      alloc_chk (WHERE, minval_chi);
      maxval_chi = (double *) calloc (n_compnts, sizeof (double));
      alloc_chk (WHERE, maxval_chi);
      Stat_chi = alloc_double_matry (n_compnts, nloc + 1);
      alloc_chk (WHERE, Stat_chi);
      delta_Val = (double *) calloc (nloc + 1, sizeof (double));
      alloc_chk (WHERE, delta_Val);
      delta_Max_chi = (double *) calloc (nloc + 1, sizeof (double));
      alloc_chk (WHERE, delta_Max_chi);

      for (i = 0; i < n_compnts; i++)
      {
         minval_chi[i] = 10000;
         maxval_chi[i] = 0;
      }
   }

   return;
}

/**
 * Function to assign the IBD measures that will be used in lm_ibdtests
 */
void initialize_score (Measure ** score_aff)
{
   Measure *pMeasure = NULL;
   int   num_ibd = 0;
   pMeasure =
      (Measure *) calloc ((SpairsOn + RobdomOn + SAffUnaffOn + LambdaOn),
                          sizeof (Measure));
   alloc_chk (WHERE, pMeasure);

   if (SpairsOn)
   {
      pMeasure[num_ibd] = spair;
      num_ibd = num_ibd + 1;
   }
   if (RobdomOn)
   {
      pMeasure[num_ibd] = robdom;
      num_ibd = num_ibd + 1;
   }
   if (SAffUnaffOn)
   {
      pMeasure[num_ibd] = Saffunaff;
      num_ibd = num_ibd + 1;
   }
   if (LambdaOn)
   {
      pMeasure[num_ibd] = Calculate_Likelihood_Lambda;
      num_ibd = num_ibd + 1;
   }
   *score_aff = pMeasure;

   return;
}

/* Function to assign values to exreal[] for Slambda and assign values
 * to exint[] for Srobdom
 */
void initialize_valarray (double *paff, int SEG_LAMBDA)
{
   int   i, c;
   Param_Val_Array[0] = (double) SEG_LAMBDA;
   for (i = 1; i <= SEG_LAMBDA; i++)
   {
      Param_Val_Array[i] = (double) ((double) i / 10.0);
   }

   for (c = 0; c < n_compnts; c++)
   {
      Val_Array[c][0] = (double) PermutEnable;
      for (i = 0; i < pedsize; i++)
      {
         Val_Array[c][i + 1] = paff[i];
      }
      for (i = 0; i <= SEG_LAMBDA; i++)
      {
         Val_Array[c][(pedsize) + 1 + i] = Param_Val_Array[i];
      }
   }
   if (RobdomOn)
   {
      base[0] = 0;
      base[1] = 7;
   }

   return;
}

/**
 * Function to calculate the mean and variance of different allele-sharing
 * statistics for normality-based test
 */
void Calculate_Stat (int nsw)
{
   int   t, c;
   if (DeltaOn)
   {
      for (c = 0; c < n_compnts; c++)
      {
         nullmeandelta_chi[c] = 0;
         nullvariancedelta_chi[c] = 0;
      }
   }
   for (t = 0; t < NIt; ++t)
   {

      realize_null (0, 0, nsw);
      /* set the genes         */
      set_FGL (0);

      /* score the ibd measure -- store the value (NIt values!!) */
      for (c = 0; c < n_compnts; c++)
      {
         int   Count = 0;
         if (SpairsOn)
         {
            double Value_S = 0;
            double Indicator = 0;
            Value_S = spair (c, 0, 0, &Indicator);
            Mean_Val[c][Count] = Mean_Val[c][Count] + Value_S;

            Variance_Val[c][Count] = Variance_Val[c][Count] + Value_S * Value_S;
            Count = Count + 1;
         }
         if (RobdomOn)
         {
            double Value_S = 0;
            base[0] = 0;
            base[1] = 7;
            Value_S = robdom (c, 0, 0, base);
            Mean_Val[c][Count] = Mean_Val[c][Count] + Value_S;
            Variance_Val[c][Count] = Variance_Val[c][Count] + Value_S * Value_S;
            Count = Count + 1;
         }
         if (LambdaOn)
         {
            double like = 0;
            Val_Array[c][0] = 0;
            like = Calculate_Likelihood_Lambda (c, 0, 0, Val_Array[c]);
            Mean_Val[c][Count] = Mean_Val[c][Count] + like;
            Variance_Val[c][Count] = Variance_Val[c][Count] + like * like;

            Count = Count + 1;
         }

         if (DeltaOn)
         {
            double value_S = 0;
            double Indicator = 0;
            value_S = spair (c, 0, 0, &Indicator);
            nullmeandelta_chi[c] = nullmeandelta_chi[c] + value_S;
            nullvariancedelta_chi[c] =
               nullvariancedelta_chi[c] + value_S * value_S;
            if (value_S < minval_chi[c])
            {
               minval_chi[c] = value_S;
            }
            if (value_S > maxval_chi[c])
            {
               maxval_chi[c] = value_S;
            }
         }
      }
   }

   return;
}

/**
 * Function to initialize IBD measures
 */
void reset_measurevars (int nloc)
{
   int   c, i, j;
   for (c = 0; c < n_compnts; c++)
   {
      for (i = 0; i < NPermutIt; i++)
      {
         for (j = 0; j < (nloc + 1); j++)
         {
            if (RobdomOn)
            {
               robdomstat[c][i][j] = 0;
            }
            if ((SAffUnaffOn))
            {
               newstat[c][i][j] = 0;
            }
            if (SpairsOn)
            {
               spairs[c][i][j] = 0;
            }
            if (LambdaOn)
            {
               newstat_Lambda[c][i][j] = 0;
            }
         }
      }
   }

   return;
}

/**
 * Function to compute the allele-sharing statistics for normality-based test
 */
void assign_values (int c, int locus)
{
   int   Count = 0;

   if (SpairsOn)
   {
      double Value_S = 0;
      double Indicator = 0;
      Value_S = spair (c, locus, 0, &Indicator);
      Statistic[c][locus][Count] = Statistic[c][locus][Count] + Value_S;

      Count = Count + 1;
   }
   if (RobdomOn)
   {
      double Value_S = 0;
      base[0] = 0;
      Value_S = robdom (c, locus, 0, base);
      Statistic[c][locus][Count] = Statistic[c][locus][Count] + Value_S;

      Count = Count + 1;

   }
   if (LambdaOn)
   {
      double like = 0;
      Val_Array[c][0] = 0;
      like = Calculate_Likelihood_Lambda (c, locus, 0, Val_Array[c]);
      Statistic[c][locus][Count] = Statistic[c][locus][Count] + like;

      Count = Count + 1;
   }

   return;
}

/**
 * Function to compute the allele-sharing statistics for permutation test
 */
void reassign_values (int c, int iter1, int locus)
{
   if (SAffUnaffOn)
   {
      newstat[c][iter1][locus] =
         newstat[c][iter1][locus] + Saffunaff (c, locus, exint1[c], 0);
   }
   if (SpairsOn)
   {
      double value_S = 0;
      double Indicator = 1.0;
      value_S = spair (c, locus, exint[c], &Indicator);
      spairs[c][iter1][locus] = spairs[c][iter1][locus] + value_S;
   }
   if (RobdomOn)
   {

      base[0] = 1;
      robdomstat[c][iter1][locus] =
         robdomstat[c][iter1][locus] + robdom (c, locus, exint[c], base);
   }
   if (LambdaOn)
   {
      double like = 0;
      Val_Array[c][0] = 1;
      like = Calculate_Likelihood_Lambda (c, locus, exint[c], Val_Array[c]);
      newstat_Lambda[c][iter1][locus] = newstat_Lambda[c][iter1][locus] + like;
   }

   return;
}

/**
 * Function to write the IBD measures from each MCMC scan in a file
 */
void file_write (int Total_Sampling, int nloc)
{
   FILE *write_fp = NULL;
   int   len = 0;
   char  buffer[256];
   int   c, iter1, locus;
   len = sprintf (buffer, "./file_%d", Total_Sampling);

   write_fp = open_chkq (WHERE, buffer, "w+");

   for (iter1 = 0; iter1 < NPermutIt; iter1++)
   {
      for (locus = 1; locus < (nloc + 1); locus++)
      {
         if (SAffUnaffOn)
         {
            double newstat_val = 0;
            for (c = 0; c < n_compnts; c++)
            {
               newstat_val = newstat_val + newstat[c][iter1][locus];
            }
            len = sprintf (buffer, "%7.4f\n", newstat_val);
            fwrite (buffer, 1, len, write_fp);
         }
         if (SpairsOn)
         {
            double spair_val = 0;
            for (c = 0; c < n_compnts; c++)
            {
               spair_val = spair_val + spairs[c][iter1][locus];
            }
            len = sprintf (buffer, "%7.4f\n", spair_val);
            fwrite (buffer, 1, len, write_fp);
         }
         if (RobdomOn)
         {
            double rob_val = 0;
            for (c = 0; c < n_compnts; c++)
            {
               rob_val = rob_val + robdomstat[c][iter1][locus];
            }

            len = sprintf (buffer, "%7.4f\n", rob_val);
            fwrite (buffer, 1, len, write_fp);
         }
         if (LambdaOn)
         {
            double lambda_val = 0;
            for (c = 0; c < n_compnts; c++)
            {
               lambda_val = lambda_val + newstat_Lambda[c][iter1][locus];
            }

            len = sprintf (buffer, "%7.4f\n", lambda_val);
            fwrite (buffer, 1, len, write_fp);
         }
      }
   }

   fclose (write_fp);

   return;
}

void printMatry ()
{
    /*** prints all permutations*******/
#if 0
   int   c, v, v1;
   for (c = 0; c < n_compnts; c++)
   {
      printf ("Permutation for component %d\n", c);
      for (v = 0; v < NPermutIt; v++)
      {
         for (v1 = 0; v1 < nTotalSize; v1++)
         {
            printf ("%d ", matry[c][v][v1]);
         }
         printf ("(%d)\n", v);
      }
      printf ("(%d)\n", c);
   }
#endif

   return;
}

/*****************************************************************************************/

/**
 * Function to maximize the likelihood under delta Model
 */
void Max_Delta (int nloc, int Total_Sampling)
{

   double minval_final = 1000;
   double maxval_final = 0;
   int   c, locus;
   for (c = 0; c < n_compnts; c++)
   {

      nullmeandelta_chi[c] = (double) (nullmeandelta_chi[c] / NIt);
      nullvariancedelta_chi[c] =
         (double) (nullvariancedelta_chi[c] / NIt) -
         (double) (nullmeandelta_chi[c] * nullmeandelta_chi[c]);

      if (nullvariancedelta_chi[c] > 0)
      {
         minval_chi[c] =
            (double) (sqrt (nullvariancedelta_chi[c]) /
                      (nullmeandelta_chi[c] - minval_chi[c]));
         maxval_chi[c] =
            (double) ((sqrt (nullvariancedelta_chi[c]) /
                       (maxval_chi[c] - nullmeandelta_chi[c])));
      }
      else
      {
         minval_chi[c] = 1000;
         maxval_chi[c] = 0;
      }
   }

   for (locus = 0; locus < (nloc + 1); locus++)
   {
      double delta = 0;
      double OldVal = -999;
      minval_final = 1000;
      maxval_final = 0;
      delta_Val[locus] = 0;
      for (c = 0; c < n_compnts; c++)
      {
         if ((minval_chi[c] < minval_final) && (minval_chi[c] > 0))
         {
            minval_final = minval_chi[c];

         }
         if ((maxval_chi[c] > maxval_final) && (minval_chi[c] > 0))
         {
            maxval_final = maxval_chi[c];
         }
      }

      /*  minval_final= minval_final * (double)(sqrt((double)n_compnts));
         printf("minval-finall %7.4f\n", minval_final); */
      while ((delta <= (double) (minval_final)))
      {
         double Stat2 = 0;
         for (c = 0; c < n_compnts; c++)
         {
            double Stat1 = 0;
            if (nullvariancedelta_chi[c] > 0)
            {
               Stat1 =
                  ((double)
                   ((Stat_chi[c][locus] / Total_Sampling) -
                    nullmeandelta_chi[c]) / sqrt (nullvariancedelta_chi[c]));

               Stat2 = Stat2 + log ((double) (1.0 + delta * Stat1));
            }
         }

         if ((OldVal < Stat2))
         {
            OldVal = Stat2;
            delta_Max_chi[locus] = delta;
         }
         delta = delta + .01;
      }
      delta_Val[locus] = 2 * (OldVal);
   }

   return;
}

/**
 * Function to maximize the likelihood under (lambda,p) model.
 */
void Max_lambdap (int nloc, int Total_Sampling, double IntervalSegL,
                  double IntervalSegP)
{
   double Old_Value, likelihood_value, null_like;
   int   c, locus, v, v1, v2;

   null_like = 0.0;
   for (locus = 0; locus < (nloc + 1); locus++)
   {
      Old_Value = -999;
      for (v = 0; v < NumOfSegL; v++)
      {
         for (v2 = 0; v2 < NumOfSegL; v2++)
         {
            for (v1 = 0; v1 < NumOfSegP; v1++)
            {
               likelihood_value = 0;

               for (c = 0; c < n_compnts; c++)
               {
                  likelihood_value =
                     likelihood_value +
                     log ((double)
                          (likelihood_chi[c][locus][v][v2][v1] /
                           Total_Sampling));
                  if ((locus == 0) && (v1 == 0) && (v == 5) && (v2 == 5))
                  {
                     null_like =
                        null_like +
                        log ((double)
                             (likelihood_chi[c][locus][v][v2][v1] /
                              Total_Sampling));
                  }
               }

               if (likelihood_value > Old_Value)
               {
                  Old_Value = likelihood_value;
#if 0
                  double lambda_aff_final, lambda_unaff_final, p_final;

                  lambda_aff_final = 1.0 - IntervalSegL * v;
                  lambda_unaff_final = 0.0 + IntervalSegL * v2;
                  p_final = .1 + IntervalSegP * v1;
#endif
                  store_index[locus] = v1;
               }
            }
         }
      }

      likestat[locus] = 2 * (Old_Value - null_like);
   }

   return;
}

/**
 * Function to compute the likelihood under (lambda,p) model
 */
void Likelambdap_Computation (int c, int nloc, double IntervalSegL,
                              double IntervalSegP)
{
   int   locus, v1, v2, v;
   double p, lambda_aff, lambda_unaff;
   p = 0.1;
   lambda_aff = 1.0;
   lambda_unaff = 0.0;
   v1 = 0;
   while (p <= .9)
   {
      v = 0;
      lambda_aff = 1.0;
      while ((lambda_aff >= .5))
      {
         lambda_unaff = 0.0;
         v2 = 0;
         while ((lambda_unaff <= .5))
         {
            for (locus = 0; locus <= nloc; locus++)
            {
               likelihood_chi[c][locus][v][v2][v1] =
                  likelihood_chi[c][locus][v][v2][v1] +
                  Calculate_Likelihood (c, n_founders[c], trt_obs, locus, p,
                                        lambda_aff, lambda_unaff, v1);
            }
            lambda_unaff = lambda_unaff + IntervalSegL;
            v2 = v2 + 1;
         }
         lambda_aff = lambda_aff - IntervalSegL;
         v = v + 1;
      }
      p = p + IntervalSegP;
      v1 = v1 + 1;
   }

   return;
}

/**
 * Function to compute the likelihood under delta model
 */
void Likedelta_Computation (int c, int nloc)
{
   int   locus;

   for (locus = 0; locus <= nloc; locus++)
   {
      double value_S = 0;
      double Indicator = 0;
      value_S = spair (c, locus, 0, &Indicator);
      Stat_chi[c][locus] = Stat_chi[c][locus] + value_S;
   }

   return;
}

/**
 * Function to compute the correlation under (lambda,p) model
 */
double Corr_Computation ()
{
   double correlation = 0;
   int   locus = 1;

   double X = (double) sqrt ((double) (Variance1[locus][store_index[locus]]));

   double Y1 = (double) sqrt ((double) (Variance2[locus][store_index[locus]]));

   if ((Variance1[locus][store_index[locus]] == 0)
       || (Variance2[locus][store_index[locus]] == 0))
   {
      correlation = 0;
   }
   else
   {
      correlation =
         -(double) ((Covariance[locus][store_index[locus]]) /
                    ((double) (X * Y1)));
   }
   printf ("Correlation %7.4f for %d locus\n", correlation, locus);

   return correlation;
}

/**
 * Function to compute the p-value under (lambda,p) model
 */
void pVal_Computation (int nloc)
{
   double ValueA, ValueB;
   double final_p_like = 0, correlation = 0;
   double final_p_delta = 0;
   int   locus;
   if (Lambda_pOn)
   {
      if ((Nul_Hyp))
      {
         correlation = Corr_Computation ();
      }
      else
      {
         correlation = CORR;
      }
      ValueA = 1. / PPI * acos (correlation);
      ValueB = 1. / PPI * (M_PI - acos (correlation));
   }

   for (locus = 1; locus <= nloc; locus++)
   {
      if (Lambda_pOn)
      {
         final_p_like = cdfLR (likestat[locus], ValueA, ValueB);
      }
      if (DeltaOn)
      {
         final_p_delta = .5 * cdfdelta (delta_Val[locus]);
      }

      prntIBDTLocPos (locus);

      if (Lambda_pOn)
      {
         printf (" %8.4f %7.4f", likestat[locus], final_p_like);
      }
      if (DeltaOn)
      {
         printf (" %8.4f %7.4f %7.4f", delta_Max_chi[locus],
                 delta_Val[locus], final_p_delta);
      }
      printf ("\n");
   }

   return;
}

/**
 * Function to compute the p-value under normality-based test.
 */
void Norm_Compute (int nloc, int Total_Sampling)
{
   int   i, j, c;
   double q_norm;

   for (i = 1; i <= (nloc); i++)
   {
      int   bnewtag, bspairtag, brobtag, blambdatag;
      int   nNoOfStatOfInts = SpairsOn + SAffUnaffOn + RobdomOn + LambdaOn;
      bnewtag = SAffUnaffOn;
      bspairtag = SpairsOn;
      brobtag = RobdomOn;
      blambdatag = LambdaOn;

      prntIBDTLocPos (i);

      for (j = 0; j < nNoOfStatOfInts; j++)
      {
         double Stat_Val = 0;
         Weight = 0;
         if (i == 1)
         {
            for (c = 0; c < n_compnts; c++)
            {
               Mean_Val[c][j] = (double) (Mean_Val[c][j] / NIt);
               Variance_Val[c][j] =
                  (double) ((Variance_Val[c][j]) / NIt) -
                  (Mean_Val[c][j] * Mean_Val[c][j]);

               /* printf ("%7.4f=mean %7.4f= variance\n", Mean_Val[c][j],
                  Variance_Val[c][j]); */
            }
         }

         Stat_Val = 0;

         for (c = 0; c < n_compnts; c++)
         {
            if (Variance_Val[c][j] > 0)
            {
               Weight = Weight + 1;
            }
         }
         /* printf("Weight= %7.4f\n",Weight); */

         for (c = 0; c < n_compnts; c++)
         {
            if (Variance_Val[c][j] > 0)
            {
               /* printf("Value for locus %d is %7.4f\n",i+1,
                  Statistic[c][i][j]/Total_Sampling);  */
               Stat_Val =
                  Stat_Val +
                  (double) (((double) (Statistic[c][i][j] / Total_Sampling) -
                             Mean_Val[c][j]) / sqrt (Variance_Val[c][j]));
            }
         }
         Stat_Val = ((double) (1 / sqrt ((double) Weight))) * Stat_Val;

         q_norm = 0;
         q_norm = normcdf (Stat_Val);

         if (bnewtag)
         {
            printf ("  %7.4f %7.4f", Stat_Val, q_norm);
            bnewtag = 0;
         }

         else if (bspairtag)
         {
            printf ("  %7.4f %7.4f", Stat_Val, q_norm);
            bspairtag = 0;
         }
         else if (brobtag)
         {
            printf ("  %7.4f %7.4f", Stat_Val, q_norm);
            brobtag = 0;
         }
         else if (blambdatag)
         {
            printf ("  %7.4f %7.4f", Stat_Val, q_norm);
            blambdatag = 0;
         }
      }
      printf ("\n");
   }
   if (Mean_Val)
   {
      for (c = 0; c < n_compnts; c++)
      {
         if (Mean_Val[c])
            free (Mean_Val[c]);
      }
      free (Mean_Val);
   }

   if (Variance_Val)
   {
      for (c = 0; c < n_compnts; c++)
      {
         if (Variance_Val[c])
            free (Variance_Val[c]);
      }
      free (Variance_Val);
   }

   if (Statistic)
   {
      for (c = 0; c < n_compnts; c++)
      {
         if (Statistic[c])
         {
            for (j = 0; j < (nloc + 1); j++)
            {
               if (Statistic[c][j])
               {
                  free (Statistic[c][j]);
               }
            }
            free (Statistic[c]);
         }
      }
      free (Statistic);
   }

   return;
}

void free_memory (int nloc)             /* free memory * */
{
   free_int_matry (size_aff, n_compnts);
   free_int_matry (size_unaff, n_compnts);
   free_int_matry (Size, n_compnts);

   free_1d ((void *) &Group);
   free_1d ((void *) &tot_affected);
   free_1d ((void *) &tot_unaffected);
   free_1d ((void *) &Total_Size);

   free_int_matry (exint, n_compnts);

   free_1d ((void *) &trt_data);
   free_1d ((void *) &trt_obs);

   free_3_dim_double_array (robdomstat, n_compnts, NPermutIt);
   free_1d ((void *) &base);

   free_3_dim_double_array (newstat, n_compnts, NPermutIt);
   free_3_dim_double_array (spairs, n_compnts, NPermutIt);
   free_3_dim_double_array (newstat_Lambda, n_compnts, NPermutIt);
   free_int_matry (Affect_resimulation, NPermutIt);

   free_1d ((void *) &n_founders);
   free_3_dim_int_array (matry, n_compnts, NPermutIt);

   free_1d ((void *) &pQuantileList);
   free_1d ((void *) &nullmean);
   free_1d ((void *) &nullvariance);

   free_1d ((void *) &paff);
   free_1d ((void *) &Val_Array);
   free_1d ((void *) &Param_Val_Array);

   free_double_matry (Covariance, NLoci);
   free_double_matry (Variance1, NLoci);
   free_double_matry (Variance2, NLoci);

   return;
}

void free_chisq_variables (void)
{
   free_5_dim_array (likelihood_chi, n_compnts, NLoci, NumOfSegL, NumOfSegL);

   free_1d ((void *) &delta_Max_chi);
   free_1d ((void *) &delta_Val);
   free_1d ((void *) &likestat);

   free_1d ((void *) &nullvariancedelta_chi);
   free_1d ((void *) &nullmeandelta_chi);
   free_1d ((void *) &minval_chi);
   free_1d ((void *) &maxval_chi);
   free_1d ((void *) &store_index);

   free_double_matry (Stat_chi, n_compnts);

   return;
}

#if 0
void Formatting ()
{
   printf ("Locus\t");

   if (SAffUnaffOn)
   {
      printf ("Saffunaff(p value)\t");
   }
   if (SpairsOn)
   {
      printf ("Spairs(p value)\t");
   }
   if (RobdomOn)
   {
      printf ("Srobdom(p value)\t");
   }
   if (LambdaOn)
   {
      printf ("Slambda(p value)\t");
   }
   printf ("\n");
   printf ("************************************\n");

   return;
}
#endif
#if 0
/**
 * assigning values to exint[] for permutation test
 ***/
void assign_exint (int **ex_ar, int **ex_ar1, int iter1, int c)/** assigning values to exint[] for permutation test ***/
{

   int   countv = 0;
   int  *ex_array = *ex_ar;
   int  *ex_array1 = *ex_ar1;
   ex_array[0] = tot_affected[c];
   ex_array[1] = Total_Size[c] - tot_affected[c];
   while (countv < tot_affected[c])
   {
      ex_array[countv + 2] = matry[c][iter1][countv];
      if (SAffUnaffOn)
         ex_array1[(2 * Group[c] + 1) + countv + 2] = matry[c][iter1][countv];
      countv = countv + 1;
   }
   while (countv < Total_Size[c])
   {
      ex_array[countv + 2] = matry[c][iter1][countv];
      if (SAffUnaffOn)
         ex_array1[(2 * Group[c] + 1) + countv + 2] = matry[c][iter1][countv];
      countv = countv + 1;
   }

   return;
}
#endif
