/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

void  Peeling_routine_Permutation (int c, Ind * First_Element,
                                   FILE * fp, node ** Sibship_aff,
                                   node ** Sibship_unaff, node ** size_a,
                                   node ** size_u, node ** size_t, int *group);
int   fac (int n);
int   NChooseR (int n, int r);

int  *FlagTable1_Lambda = NULL;

int fac (int n)
{
   int   result;
   if (n < 0)
   {
      return -1;
   }
   if ((n == 1) || (n == 0))
   {
      return 1;
   }
   result = n * fac (n - 1);
   return result;
}

int NChooseR (int n, int r)
{
   int   result;
   if (r > n)
   {
      return -1;
   }
   if (n == 0)
   {
      return 1;
   }
   else
   {
      result = fac (n) / (fac (r) * fac (n - r));
   }
   return result;
}

/* Writing the individuals whose affectation status can be permuted
   in a file in a specific order */
int Write_Permutation (char *pStrPermfile, char *pStrObsfile)
{
   Ind  *First_Element = NULL;
   int   c, i, len, j;
   double nNoOfPossiblePermutations = 1;

   int  *group = NULL;
   char  buffer[200];
   node **Sibship_aff = NULL;
   node **Sibship_unaff = NULL;
   node **size_a = NULL;
   node **size_u = NULL;
   node **size_t = NULL;
   /* node ** Head_Ptr ;
      node ** Head1_Ptr;
      node ** Head2_Ptr; */
   FILE *fp;
   FILE *fp2;

   Sibship_aff = (node **) calloc (n_compnts, sizeof (node *));
   alloc_chk (WHERE, Sibship_aff);

   Sibship_unaff = (node **) calloc (n_compnts, sizeof (node *));
   alloc_chk (WHERE, Sibship_unaff);

   size_a = (node **) calloc (n_compnts, sizeof (node *));
   alloc_chk (WHERE, size_a);

   size_u = (node **) calloc (n_compnts, sizeof (node *));
   alloc_chk (WHERE, size_u);

   size_t = (node **) calloc (n_compnts, sizeof (node *));
   alloc_chk (WHERE, size_t);
   group = (int *) calloc (n_compnts, sizeof (int));
   alloc_chk (WHERE, group);

   FlagTable1_Lambda = (int *) calloc (pedsize, sizeof (int));
   alloc_chk (WHERE, FlagTable1_Lambda);

   for (i = 0; i < pedsize; i++)
   {
      FlagTable1_Lambda[i] = 0;
   }
   if (NPermutIt > 1)
   {
      fp = open_chkq (WHERE, pStrPermfile, "w");
   }
   fp2 = open_chkq (WHERE, pStrObsfile, "w");

   for (c = 0; c < n_compnts; c++)
   {
      for (i = 0; i < pedsize; i++)
      {
         if (nghd[i].component == (c + 1))
         {
            First_Element = &nghd[i];

            Peeling_routine_Permutation (c, First_Element, fp,
                                         &Sibship_aff[c], &Sibship_unaff[c],
                                         &size_a[c], &size_u[c], &size_t[c],
                                         &group[c]);
         }
      }
   }

   size_aff = (int **) calloc (n_compnts, sizeof (int *));
   alloc_chk (WHERE, size_aff);

   size_unaff = (int **) calloc (n_compnts, sizeof (int *));
   alloc_chk (WHERE, size_unaff);

   Size = (int **) calloc (n_compnts, sizeof (int *));
   alloc_chk (WHERE, Size);

   Group = (int *) calloc (n_compnts, sizeof (int));
   alloc_chk (WHERE, Group);

   for (c = 0; c < n_compnts; c++)
   {
      size_aff[c] = (int *) calloc (group[c], sizeof (int));
      alloc_chk (WHERE, size_aff[c]);

      size_unaff[c] = (int *) calloc (group[c], sizeof (int));
      alloc_chk (WHERE, size_unaff[c]);

      Size[c] = (int *) calloc (group[c], sizeof (int));
      alloc_chk (WHERE, Size[c]);
   }
   for (c = 0; c < n_compnts; c++)
   {
      node *temp_Ptr = size_a[c];
      node *temp1_Ptr = size_u[c];
      node *temp2_Ptr = size_t[c];
      for (i = 0; i < group[c]; i++)
      {
         if (temp_Ptr != NULL)
         {
            size_aff[c][i] = temp_Ptr->number;
            temp_Ptr = temp_Ptr->next;
         }

         if (temp1_Ptr != NULL)
         {
            size_unaff[c][i] = temp1_Ptr->number;
            temp1_Ptr = temp1_Ptr->next;
         }

         if (temp2_Ptr != NULL)
         {
            Size[c][i] = temp2_Ptr->number;
            temp2_Ptr = temp2_Ptr->next;
         }
      }
      Group[c] = group[c];
   }
   nNoOfPossiblePermutations = 1;
   for (c = 0; c < n_compnts; c++)
   {
      double val1 = 1;
      for (i = 0; i < group[c]; i++)
      {
         int   val = NChooseR (Size[c][i], size_aff[c][i]);
         if (val < 0)
         {
            printf
               ("Invalid value for calculating combination NChooseR(%d,%d)\n",
                Size[c][i], size_aff[c][i]);
            return 0;
         }
         val1 = val1 * (double) val;
         nNoOfPossiblePermutations = nNoOfPossiblePermutations * (double) val;
      }
      printf (" Total Number of Distinct Permutations for Pedigree %d: %d\n",
              c, (int) val1);
   }
   printf (" Total Number of Distinct Permutations : %d\n\n",
           (int) nNoOfPossiblePermutations);

   if (NPermutIt > 1)
   {
      int   Tag = 0;
      for (c = 0; c < n_compnts; c++)
      {
         node *temp_Ptr = Sibship_aff[c];
         node *temp1_Ptr = Sibship_unaff[c];
         for (i = 0; i < group[c]; i++)
         {
            if (size_unaff[c][i] > 0)
            {
               Tag = 1;
            }

            for (j = 0; j < size_aff[c][i]; j++)
            {
               len = sprintf (buffer, "%d  ", temp_Ptr->number);
               fwrite (buffer, len, 1, fp);

               temp_Ptr = temp_Ptr->next;
            }
            for (j = 0; j < size_unaff[c][i]; j++)
            {
               len = sprintf (buffer, "%d  ", temp1_Ptr->number);
               fwrite (buffer, len, 1, fp);
               temp1_Ptr = temp1_Ptr->next;
            }
         }
         len = sprintf (buffer, "\n");
         fwrite (buffer, len, 1, fp);
      }
      if (Tag == 0)
      {
         if (NPermutIt != 2)
         {
            printf ("ERROR: No unaffected people in data:"
                    " Permutation Test cannot be performed\n");
            return 0;
         }
      }
   }
   if (NPermutIt > 1)
      fclose (fp);
   for (c = 0; c < n_compnts; c++)
   {
      node *temp_Ptr = Sibship_aff[c];
      node *temp1_Ptr = Sibship_unaff[c];
      for (i = 0; i < group[c]; i++)
      {
         for (j = 0; j < size_aff[c][i]; j++)
         {
            len = sprintf (buffer, "%d  ", temp_Ptr->number);
            fwrite (buffer, len, 1, fp2);
            temp_Ptr = temp_Ptr->next;
         }
      }
      for (i = 0; i < group[c]; i++)
      {
         for (j = 0; j < size_unaff[c][i]; j++)
         {
            len = sprintf (buffer, "%d  ", temp1_Ptr->number);
            fwrite (buffer, len, 1, fp2);
            temp1_Ptr = temp1_Ptr->next;
         }
      }
      len = sprintf (buffer, "\n");
      fwrite (buffer, len, 1, fp2);
   }

   fclose (fp2);
   for (c = 0; c < n_compnts; c++)
   {
      while (Sibship_aff[c] != NULL)
      {
         node *temp = Sibship_aff[c];
         Sibship_aff[c] = Sibship_aff[c]->next;
         free (temp);
      }
      while (Sibship_unaff[c] != NULL)
      {
         node *temp = Sibship_unaff[c];
         Sibship_unaff[c] = Sibship_unaff[c]->next;
         free (temp);
      }
      while (size_a[c] != NULL)
      {
         node *temp = size_a[c];
         size_a[c] = size_a[c]->next;
         free (temp);
      }
      while (size_u[c] != NULL)
      {
         node *temp = size_u[c];
         size_u[c] = size_u[c]->next;
         free (temp);
      }
      while (size_t[c] != NULL)
      {
         node *temp = size_t[c];
         size_t[c] = size_t[c]->next;
         free (temp);
      }
   }

   if (Sibship_aff)
      free (Sibship_aff);
   if (Sibship_unaff)
      free (Sibship_unaff);

   if (size_a)
      free (size_a);
   if (size_u)
      free (size_u);
   if (size_t)
      free (size_t);
   if (group)
      free (group);

   if (FlagTable1_Lambda)
      free (FlagTable1_Lambda);

   return 1;
}

/* Function to list the individuals whose affectation statuses can be permuted
   in the permutation test */
void Peeling_routine_Permutation (int c, Ind * First_Element, FILE * fp,
                                  node ** Sibship_aff, node ** Sibship_unaff,
                                  node ** size_a, node ** size_u,
                                  node ** size_t, int *group)
{
   Ind  *spousePtr;
   Indlist *kidsPtr = NULL;
   Mar  *marCurrentPtr = NULL;
   Marlist *marListPtr = NULL;
   node *Head_Ptr = *Sibship_aff;
   node *Head1_Ptr = *Sibship_unaff;
   node *Head_Ptr2 = *size_a;
   node *Head_Ptr3 = *size_u;
   node *Head_Ptr4 = *size_t;
   int   size1 = 0, size2 = 0;
   node *temp4 = NULL;
   node *temp1 = NULL;
   node *temp2 = NULL;

   if (First_Element == &nullnode)
   {
      return;
   }
   else if (FlagTable1_Lambda[First_Element->index] == 1)
   {
      return;
   }
   else
   {
      marListPtr = First_Element->marriages;
      if (marListPtr == NULL)
      {
         FlagTable1_Lambda[First_Element->index] = 1;
         return;
      }
      else
      {
         marCurrentPtr = marListPtr->current;
         if (marCurrentPtr != NULL)
         {
            spousePtr = marCurrentPtr->spouse;
            kidsPtr = marCurrentPtr->kids;
            size1 = 0;
            size2 = 0;
            while (kidsPtr != NULL)
            {
               if (nghd[kidsPtr->current->index].d_dat != NULL)
               {
                  if ((nghd[kidsPtr->current->index].d_dat[0] == 2)
                      && (kidsPtr->current->marriages == NULL))
                  {
                     ++size1;
                  }
                  else if ((nghd[kidsPtr->current->index].d_dat[0] == 1)
                           && (kidsPtr->current->marriages == NULL))
                  {
                     ++size2;
                  }
               }
               kidsPtr = kidsPtr->next;
            }
            if ((size1 >= 1) || (size2 >= 1))
            {
               temp4 = (node *) calloc (1, sizeof (node));
               alloc_chk (WHERE, temp4);

               temp1 = (node *) calloc (1, sizeof (node));
               alloc_chk (WHERE, temp1);

               temp2 = (node *) calloc (1, sizeof (node));
               alloc_chk (WHERE, temp2);

               kidsPtr = marCurrentPtr->kids;
               while (kidsPtr != NULL)
               {
#if 0
                  if ((nghd[kidsPtr->current->index].d_dat != NULL)
                      && (kidsPtr->current->marriages == NULL)
                      && (NPermutIt > 1))
                  {
                     len = sprintf (buffer, "%d ", kidsPtr->current->index);
                     fwrite (buffer, 1, len, fp);
                  }
#endif
                  if (nghd[kidsPtr->current->index].d_dat != NULL)
                  {
                     if ((nghd[kidsPtr->current->index].d_dat[0] == 2)
                         && (kidsPtr->current->marriages == NULL))
                     {
                        node *temp3 = NULL;

                        temp3 = (node *) calloc (1, sizeof (node));
                        alloc_chk (WHERE, temp3);

                        temp3->number = kidsPtr->current->index;
                        temp3->next = Head_Ptr;
                        Head_Ptr = temp3;
                     }
                     if ((nghd[kidsPtr->current->index].d_dat[0] == 1)
                         && (kidsPtr->current->marriages == NULL))
                     {
                        node *temp3 = NULL;

                        temp3 = (node *) calloc (1, sizeof (node));
                        alloc_chk (WHERE, temp3);

                        temp3->number = kidsPtr->current->index;
                        temp3->next = Head1_Ptr;
                        Head1_Ptr = temp3;
                     }
                  }
                  kidsPtr = kidsPtr->next;
               }
               *group = *group + 1;
               temp1->number = size1;
               temp2->number = size2;
               temp4->number = size1 + size2;
               temp1->next = Head_Ptr2;
               temp2->next = Head_Ptr3;
               temp4->next = Head_Ptr4;
               Head_Ptr2 = temp1;
               Head_Ptr3 = temp2;
               Head_Ptr4 = temp4;
            }
            if ((size1 >= 1) || (size2 >= 1))
            {
               *size_a = Head_Ptr2;

               *size_u = Head_Ptr3;

               *size_t = Head_Ptr4;
               *Sibship_aff = Head_Ptr;
               *Sibship_unaff = Head1_Ptr;
            }
         }
         FlagTable1_Lambda[First_Element->index] = 1;
         FlagTable1_Lambda[spousePtr->index] = 1;
      }
      return;
   }
}
