/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*       lodscore.h:  header file for lm_bayes, lm_linkage, gl_lods       */
/*                          and lm_twoqtl.                                */
/*                    contains #includes for header files for             */
/*                        libraries used                                  */
/*                    and #defines, typedefs, variables and               */
/*                        function prototypes                             */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef LODSCORE_H
#define LODSCORE_H

#define DEFINE_DATA

#include "parsie.h"
#include "nghds.h"
#include "pedchk.h"
#include "msample.h"
#include "lsample.h"
#include "quantset.h"
#include "rans.h"
#include "traits.h"

#ifdef LM_BAYES
#include "lm_bayes.h"
#endif /* LM_BAYES */

#ifdef MARKERS
#include "quant.h"
#endif /* MARKERS */

#ifdef TWOQTL
#include "twoqtl.h"
#include "quant.h"
#endif /* TWOQTL */

#ifdef GLLODS
#include "gl_lods.h"
#endif /* GLLODS */

#ifdef DMALLOC
#include <dmalloc.h>
#endif /* DMALLOC */

/**
 * @defgroup lodscore Lodscore programs.
 * @ingroup Programs
 * @{
 */

struct _cleanup clean_auto[] = {
{"eynw", free_fnams},
{"eynw", freeChkPed},
{"eynw", freeKey},
{"ey w", free_auto},
{"eynw", free_marek},
{"eynw", free_locnams},
{"eynw", free_ped},
{"eynw", free_nghds},
{"eynw", free_cmplists},
{"eynw", free_xxgg},
{"ey w", free_switches},
{"eynw", free_allefrq},
{"ey w", locus_peel_free},
{"eynw", free_allocate_loci},
{"ey w", free_msmpl},
{"e  w", free_sampling_cmp},
{"eynw", free_trait_pars},
{"eynw", free_traits},
{"eynw", free_gen_pen},
{"e   ", free_exact},
{""  , NULL}};

/** @} */

#endif /*LODSCORE_H*/
