/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*       lr_lods.h:   header file for lm_lods, lm_schnell                 */
/*                    contains #includes for header files for             */
/*                        libraries used                                  */
/*                    and #defines, typedefs, variables and               */
/*                        function prototypes                             */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef LR_LODS_H
#define LR_LODS_H

#define DEFINE_DATA

#include "parsie.h"
#include "nghds.h"
#include "pedchk.h"
#include "msample.h"
#include "lsample.h"
#include "quantset.h"
#include "rans.h"
#include "traits.h"

#ifdef SCHNELL
#include "quant.h"
#include "peelie.h"
#endif /* SCHNELL */

#ifdef DMALLOC
#include <dmalloc.h>
#endif /* DMALLOC */

/**
 * @defgroup lr_lods LR_Lods programs.
 * @ingroup Programs
 * @{
 */

struct _cleanup clean_auto[] = {
{"ls", free_fnams},
{"ls", freeChkPed},
{"ls", freeKey},
{"ls", free_auto},
{"ls", free_marek},
{"ls", free_locnams},
{"ls", free_ped},
{"ls", free_nghds},
{"ls", free_cmplists},
{"ls", free_xxgg},
{"ls", free_switches},
{"ls", free_allefrq},
{"ls", locus_peel_free},
{"ls", free_allocate_loci},
{"ls", free_logprob},
{"ls", free_msmpl},
{" s", free_trait_pars},
{"ls", free_traits},
{"ls", free_gen_pen},
{"ls", free_dub},
{""  , NULL}};

/** @} */

#endif /*LR_LODS_H*/
