/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*           parseauto.h:  header file for Pars/proc_auto.c, proc_autof.c     */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef PARSEAUTO_H
#define PARSEAUTO_H
#include "parsedrop.h"

/**
 * @addtogroup autozyg
 * @{
 */

int  find_tr_tloc_vmap  (void);
int  test_auto_sel      (void);
int  test_markdat       (SIM_PTR);
int  test_marknam       (SIM_PTR);
int  test_output_markers (void);
int  test_probgam       (SIM_PTR);
int  test_probgam_jnt   (SIM_PTR);
int  test_probgam_pat   (SIM_PTR);
int  test_patlab        (SIM_PTR);
int  test_affind        (void);
int  test_trait_typ     (void);
int  test_ped_trtdat    (void);
int  test_penetrnc      (void);
int  test_num_liab_classes (void);
int  get_marknam        (char *, char *, int);
int  mak_marknam        (SIM_PTR);
void alloc_marek        (void);
void sel_mark_locus     (SIM_PTR, PRDIST_PTR, int *);
void sel_tloc_locus     (PRDIST_PTR);
void sel_prntmap_marks  (PRNTMAP_PTR);
void shrink_prntmap     (PRNTMAP_PTR);
void mak_ped_dat        (void);
void alloc_tlocnam      (void);
void add_tlocnam        (int);
void mak_marek          (void);
void mak_mdist          (SIM_PTR);
void mak_tarek          (void);
void alloc_marsel       (void);
void alloc_marout       (void);
void set_trait_typ      (int);
void mak_allefrq        (PRNTMAP_PTR, PRDIST_PTR, int);
void mak_markdat        (SIM_PTR);
void mak_probgam        (void);
void mak_patlab         (void);
void mak_penetrnc       (void);
void prnt_penetrnc      (void);
void prnt_qtrait_pars   (SIM_PTR);
void prnt_markdat       (SIM_PTR);
void prnt_marknam       (SIM_PTR);
void prnt_probgam       (void);
void prnt_affind        (void);
void prnt_ped_dat       (void);
void prnt_trt_typ       (void);
void alloc_trait_pars   (int);
void pass_trait         (int, int);
void prnt_auto_pars     (void);
TRTPED_PTR find_trtped  (int);

int  is_contained_in    (const char *, const int, const int *,
                         const int, const int *, int *);

/** @} */

#endif  /*PARSEAUTO_H*/
