/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*:::::::::::::::::::::::::::::::::::::::::::::::::::;;;::::::::::::::::::*/
/*        quantset.h:  header file for Quant/                             */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::;;;:::::::::::::::*/

#ifndef QUANTSET_H
#define QUANTSET_H

/**
 * @defgroup quant libquant
 * @ingroup Libraries
 * @{
 */

#include "nghds.h"
#include "cmf.h"

GLOBAL double **x;                      /* The quantitative data;
                                           one set for each trait
                                           allocated (pedsize + 1).           */

GLOBAL int  Nq;                         /* Number actually sampled.           */

GLOBAL int *fixdex[FIXEFF];             /* Fixed effects indicators.          */

double ** allocQPed(void);
void setQObsDat (double **);

/** @} */

#endif  /*QUANTSET_H*/
