/******************************************************************************/
/*                                                                            */
/*                                                                            */
/******************************************************************************/

#define BUFLEN 256

#include "incs.h"

/* Check if the input dag file is in .gz format and, if necessary, create a   */
/* decompressed copy.                                                         */

int gunzipit (char *dagfilename)
{
   char  gzcommand[BUFLEN];
   char *gzsuf = ".gz";

   int   i;

   for (i = 0; i < BUFLEN; ++i)
      if (dagfilename[i] == '\0')
         break;

   if (!strncmp (dagfilename + i - 3, gzsuf, 3))
   {
      dagfilename[i - 3] = '\0';        /* Chop off .gz suffix.               */
      if (access (dagfilename, R_OK))
      {
         printf (" Inflating \"%s.gz\".\n", dagfilename);
         printf (" You may want to delete \"%s\" afterwards.\n", dagfilename);
         sprintf (gzcommand, " gunzip -c %s.gz > %s", dagfilename, dagfilename);
         printf ("%s\n\n", gzcommand);
         if (system (gzcommand))
         {
            printf (" Error inflating \"%s.gz\"\n\n", dagfilename);
            return 1;
         }
      }
      else
         printf (" Using inflated file \"%s\"\n\n", dagfilename);
   }

   return 0;
}
