/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#include "markers.h"
#include "gl_lods.h"

void fgl_set (FILE * fp, int c_fgl)
{
   int   i;

   for (i = 0; i < c_fgl; ++i)
   {
      set_line (fp, gg0);
      set_line (fp, gg1);
   }

   if (DebugMain)
      check_fgl ();

   return;
}

void set_line (FILE * fp, int **ggg)
{
   int   m_origin;                      /* Subscript to the first marker.     */
   int   j, k, id, fgl, fgl2, nsw, swp;
   int   unl_fgl;

   m_origin = max (NTLocs, 1);

   fscanf (fp, " %d %d %d %d", &id, &unl_fgl, &fgl, &nsw);
   ggg[0][id] = unl_fgl;

   if (nsw == 0)
      for (j = m_origin; j < NLoci; ++j)
         ggg[j][id] = fgl;

   else
   {
      j = m_origin;
      for (k = 0; k < nsw; ++k)
      {
         fscanf (fp, "%d %d", &swp, &fgl2);
         while ((j < NLoci) && (MarLod[j - m_origin] < swp))
         {
            ggg[j][id] = fgl;
            ++j;
         }
         fgl = fgl2;
      }
      while (j < NLoci)
      {
         ggg[j][id] = fgl;
         ++j;
      }
   }

   return;
}

void check_fgl ()
{
   int   m_origin;                      /* Subscript to the first marker.     */
   int   i, j;

   m_origin = max (NTLocs, 1);

   for (i = 0; i < pedsize; ++i)
   {
      if (nghd[i].obs)
      {
         printf ("\n %d %s", nghd[i].index, nghd[i].self);
         for (j = m_origin; j < NLoci; ++j)
            printf (" %d", gg0[j][i]);
         printf ("   ");
         for (j = m_origin; j < NLoci; ++j)
            printf (" %d", gg1[j][i]);
      }
   }
   printf ("\n");

   return;
}
