/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#include "nghds.h"

/* --- free_nghds:  frees nghd, marlist, mar, and indlist for kids ---- */
/*      also zeroes all pointers in these lists  */

void free_nghds (void)
{
   Marlist *cmarl, *nmarl;
   Indlist *cind, *nind;
   Mar  *cmar;
   int   p1;

   if (!nghd)
      return;

   for (p1 = 0; p1 < pedsize; ++p1)
   {
      if (nghd[p1].index != INVALID_INDEX)
      {
         cmarl = nghd[p1].marriages;
         while (cmarl)
         {
            cmar = cmarl->current;
            cind = cmar->kids;
            while (cind)
            {
               nind = cind->next;
               cind->current = NULL;
               cind->next = NULL;
               free ((void *) cind);
               cind = nind;
            }
            cmar->spouse = NULL;
            cmar->kids = NULL;
            free ((void *) cmar);
            nmarl = cmarl->next;
            cmarl->current = NULL;
            cmarl->next = NULL;
            free ((void *) cmarl);
            cmarl = nmarl;
         }
      }

      nghd[p1].ma = NULL;
      nghd[p1].pa = NULL;
      nghd[p1].marriages = NULL;
   }

   if (NghdDiscData)
   {
      free (NghdDiscData);
      NghdDiscData = NULL;
   }

   if (NghdQuanData)
   {
      free (NghdQuanData);
      NghdQuanData = NULL;
   }

   if (NghdGenoData)
   {
      free (NghdGenoData);
      NghdGenoData = NULL;
   }

   if (nghd[0].kidmeio)
      free (nghd[0].kidmeio);

   free ((void *) nghd);
   nghd = NULL;

   return;
}
