/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/******************************************************************************/
/*                                                                            */
/* Autozgy and Lodscore setup function:                                       */
/*   chkPedFil ()                                                             */
/*                                                                            */
/* This subroutine reads and checks the pedigree file.  A new one will be     */
/* written if there have been any changes to the pedigree.  Also, if an       */
/* output individuals file has been named by the user, it will be created by  */
/* calling mak_oindfil ().                                                    */
/*                                                                            */
/******************************************************************************/

#include "pedchk.h"

void chkPedFil (void)
{
   if (!chk_pedfil ())                  /* Reads pedigree file and checks     */
      give_up (ERR_qit);                /* pedigree for errors.               */

   prntStatusCPF ();

   if (!mak_opedfil ())                 /* Writes output pedigree file, if    */
      give_up (ERR_qit);                /* there are any changes to the file. */

   if (!mak_oindfil ())                 /* Writes output individuals file, if */
      give_up (ERR_qit);                /* one has been named by the user.    */

   return;
}
