/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/*
 *   Autozgy/Lodscore setup functions:
 *     allocQPed(), setQObsDat()
*/

#include "quant.h"

/**
 * Read and store pedigree data
 */
double **allocQPed (void)
{
   int   j;
   double **qdata;

   /* allocate array for quantitative data */
   if (TraitTyp == QUANTITATIVE && NTraits > 0)
   {
      qdata = malloc (NTraits * sizeof (double *));
      alloc_chk (WHERE, qdata);
      qdata[0] = malloc (PedSize * NTraits * sizeof (double));
      alloc_chk (WHERE, qdata[0]);
      for (j = 1; j < NTraits; ++j)
         qdata[j] = qdata[j - 1] + PedSize;
   }
   else
      qdata = NULL;

   return qdata;
}

/**
 * Store quantitative trait data in nghds structure.
 */
void setQObsDat (double **qdata)
{
   if (TraitTyp != QUANTITATIVE || !qdata)
      return;

   set_qdat (qdata);

   free_qdat (qdata);

   return;
}

void free_qdat (double **qdata)
{
   if (qdata)
   {
      free (qdata[0]);
      qdata[0] = NULL;
      free (qdata);
      qdata = NULL;
   }

   return;
}
