/******************************************************************************/
/*                                                                            */
/* Subroutine to generate an exponentially distributed random variable with   */
/* rate parameter lambda.  So with expected value beta = (1 / lambda).        */
/*                                                                            */
/******************************************************************************/

#include "rans.h"

double rexp (double lambda)
{
   double runif;                        /* Sample returned from rans ().      */
   double lunif;                        /* Natural log of runif variate.      */

   double result;                       /* Resulting random variate.          */

   runif = rans ();                     /* Get a sample from uniform [0, 1].  */
   lunif = log (runif);                 /* Get natural log of the variable.   */

   result = (-lunif) / lambda;          /* Scale the result.                  */

   return result;
}
